SHEBANG
# Copyright @BABOLO (C)2002..2009 http://www.babolo.ru/
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: up.m4,v 1.4 2009/06/06 00:55:33 babolo Exp $

JNTROSTUP(named,,bind9dnl
,dnl
# jailup ${kind} dir jailname jailaddr [uid [gid [yes|no]]]
#     where dir relative to ${JAILUPDIR} and ${JAILRODIR}
# bind from base system used
# Default genclass is \"named\".
# This genclass is not controled by common startshell
# and starts early - see /etc/rc.conf
# change genclass to \"bind\" by yes in last
# optional parameter to manage by common startshelldnl
)

jdir="${1}"
jailsname="${2}"
jailsaddr="${3}"
juid="${4:-53}"
jgid="${5:-1}"
if  [ "${6}" = "yes" ]; then
    genclass=bind
fi
main_dir="${JAILUPDIR}/${jdir}"
conf_dir="${JAILRODIR}/${jdir}"
if  [ -n "${CONFSHIFT}" ]; then
    conf_dir="${conf_dir}/${CONFSHIFT}"
fi

${mkdir} "${main_dir}" "${conf_dir}"
${up_mdir} "${main_dir}" ${MTREE}
${up_mdir} "${conf_dir}" ${MTREE}-conf
${up_genlist} libexec/ ${MTREE} | ${up_libexe} "${main_dir}/libexec/"
${up_genlist} libexec/ ${MTREE} | ${up_ldsh} | ${up_shlib} "${main_dir}/lib"
CONFCOPY(etc/localtime, /etc/localtime)
CONFCOPY(etc/conf, "${TEMPLATE}"-conf)
CONFCOPY(named/empty, "${TEMPLATE}"-empty)
${up_genlist} / ${MTREE}-conf | ${up_conf} "${conf_dir}/named/" "${this}/template-"

for i in `${up_genlist} empty ${MTREE}-conf`; do
    if ! [ -e "${conf_dir}/named/${i}" ]; then
        ${ln} "${conf_dir}/named/empty" "${conf_dir}/named/${i}"
    elif ! ${diff} -bBda "${conf_dir}/named/empty" "${conf_dir}/named/${i}"; then
        ${ln} -f "${conf_dir}/named/empty" "${conf_dir}/named/${i}.sample"
    fi
done

${up_acc} gr "${conf_dir}/etc" <<- EOF
	wheel:*:0:
	daemon:*:${jgid}:
	bind:*:53:
	nogroup:*:65533:
	nobody:*:65534:
EOF

${up_acc} pwt "${conf_dir}/etc" <<- EOF
	root:*:0:0::0:0:Charlie &:/:/dev/null/none
	bind:*:${juid}:${jgid}::0:0:Bind Sandbox:/:/dev/null/none
	nobody:*:65534:65534::0:0:Unprivileged user:/dev/null/none:/dev/null/none
EOF

${rm} "${conf_dir}/named/empty"
${mtree} -Ueqxp "${main_dir}" -f ${MTREE}
${mtree} -Ueqxp "${conf_dir}" -f ${MTREE}-conf

${up_adc} "${JAILUPRC}" <<- EOF
	#${genclass}	${inclass}	${jdir}	${jailsname}	${jailsaddr}	0	bind	${jgid}
EOF

      #####################################
      ####                             ####
      #### Begin of etc fill           ####
      ####                             ####
${up_adc} "${etcdir}/fstab" <<- EOF
	#devfs			${main_dir}/dev		devfs	rw		0 0
	#${conf_dir}/named	${main_dir}/namedb/m	nullfs	ro,noexec	0 0
	#${conf_dir}/etc	${main_dir}/etc		nullfs	ro,noexec	0 0
EOF

${up_adc} "${etcdir}/rc.conf" <<- EOF
	#named_program="${PREFIX}/etc/rc.d/jailup.sh"
	#named_flags="start named"
	#named_enable="YES"
EOF
      ####                             ####
      #### End of etc fill             ####
      ####                             ####
      #####################################
